class ChartMaster {
  float m_placeX;
  float m_placeY;
  float m_width;
  float m_fullHeight;
  float m_dailyValuesShiftY;

  int m_caloriesTotal;
  int m_caloriesFromFatTotal;
  int m_carbsGTotal;
  int m_carbsPTotal;
  int m_sugarsGTotal;
  int m_fiberGTotal;
  int m_fiberPTotal;
  int m_fatGTotal;
  int m_fatPTotal;
  int m_satFatGTotal;
  int m_satFatPTotal;
  int m_transFatGTotal;
  int m_proteinGTotal;
  int m_sodiumMTotal;
  int m_sodiumPTotal;
  int m_cholMTotal;
  int m_cholPTotal;

  float m_dailyValuesPlaceX;

  color[] m_colors;

  Chart m_caloriesChart;
  Chart m_caloriesFromFatChart;
  Chart m_carbsGChart;
  Chart m_sugarsGChart;
  Chart m_fiberGChart;
  Chart m_fatGChart;
  Chart m_satFatGChart;
  Chart m_transFatGChart;
  Chart m_proteinGChart;
  Chart m_sodiumMChart;
  Chart m_cholMChart;

  public ChartMaster() {
    m_placeX = 475;
    m_placeY = 71;
    m_width = 750 + 246 - m_placeX;
    m_fullHeight = 654;
    m_dailyValuesShiftY = 95;

    m_dailyValuesPlaceX = selectionsMenu.m_chooseProductsPlaceX + selectionsMenu.m_chooseProductsWidth + 14;

    m_colors = new color[5];
    m_colors[0] = color( 200, 34, 87 );
    m_colors[1] = color( 236, 197, 124 );
    m_colors[2] = color( 32, 139, 181 );
    m_colors[3] = color( 225, 133, 108 );
    m_colors[4] = color( 145, 149, 56 );

    m_caloriesChart = new Chart();
    m_caloriesFromFatChart = new Chart();
    m_carbsGChart = new Chart();
    m_sugarsGChart = new Chart();
    m_fiberGChart = new Chart();
    m_fatGChart = new Chart();
    m_satFatGChart = new Chart();
    m_transFatGChart = new Chart();
    m_proteinGChart = new Chart();
    m_sodiumMChart = new Chart();
    m_cholMChart = new Chart();
  }

  void render() {
    // Clear out chart area
    fill(255);
    noStroke();
    rect( m_placeX, 0, width - m_placeX, height );
    
    stroke(0);
    line( 564, m_placeY, 564, m_placeY + m_fullHeight );


    // Backgrounds for Daily Values statistics
    pushMatrix();
    translate( 4, 0 );
    noStroke();
    fill( 77, 77, 77 );
    for ( int i = 0; i < 7; i++ ) {
      rect( m_dailyValuesPlaceX, m_placeY + i * 95, 84, 84 );
    }

    // Daily Values Bar header
    textAlign( CENTER );
    textFont( abel12 );
    fill( 0 );
    noStroke();
    text( "Daily", m_dailyValuesPlaceX + 84 / 2, 48 );
    text( "Values", m_dailyValuesPlaceX + 84 / 2, 63 );

    // Daily Values Entries
    textAlign( CENTER );
    textFont( abel24 );
    fill( 255 );
    noStroke();
    text( m_caloriesTotal, m_dailyValuesPlaceX + 84 / 2, m_placeY + 84 * 3 / 7 );
    text( "Calories", m_dailyValuesPlaceX + 84 / 2, m_placeY + 84 * 5 / 7 );

    text( m_carbsPTotal + "%", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 1 + 84 * 3 / 7 );
    text( "Carbs", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 1 + 84 * 5 / 7 );

    text( m_fatPTotal + "%", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 2 + 84 * 3 / 7 );
    text( "Fat", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 2 + 84 * 5 / 7 );

    text( m_fiberPTotal + "%", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 3 + 84 * 3 / 7 );
    text( "Fiber", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 3 + 84 * 5 / 7 );

    text( m_proteinGTotal + "%", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 4 + 84 * 3 / 7 );
    text( "Protein", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 4 + 84 * 5 / 7 );

    text( m_sodiumPTotal + "%", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 5 + 84 * 3 / 7 );
    text( "Sodium", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 5 + 84 * 5 / 7 );

    text( m_cholPTotal + "%", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 6 + 84 * 3 / 7 );
    text( "Cholest.", m_dailyValuesPlaceX + 84 / 2, m_placeY + m_dailyValuesShiftY * 6 + 84 * 5 / 7 );
    popMatrix();

    //Charts
    m_caloriesChart.render( 621, 155, 2000 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Calories", 621 + 84 / 2, 155 - 84 + 12 );

    m_caloriesFromFatChart.render( 749, 155, 600 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Calories from Fat", 749 + 84 / 2, 155 - 84 + 12 );

    m_carbsGChart.render( 621, 290, 300 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Carbohydrates", 621 + 84 / 2, 290 - 84 + 12 );

    m_sugarsGChart.render( 749, 290, 40 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Sugars", 749 + 84 / 2, 290 - 84 + 12 );

    m_fiberGChart.render( 877, 290, 25 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Dietary Fiber", 877 + 84 / 2, 290 - 84 + 12 );

    m_fatGChart.render( 621, 433, 65 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Fat", 621 + 84 / 2, 433 - 84 + 12 );

    m_satFatGChart.render( 749, 433, 20 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Saturated Fat", 749 + 84 / 2, 433 - 84 + 12 );

    m_transFatGChart.render( 877, 433, 6 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Trans Fat", 877 + 84 / 2, 433 - 84 + 12 );

    m_proteinGChart.render( 621, 586, 50 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Protein", 621 + 84 / 2, 586 - 84 + 12 );

    m_sodiumMChart.render( 749, 586, 2400 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Sodium", 749 + 84 / 2, 586 - 84 + 12 );

    m_cholMChart.render( 877, 586, 300 );
    fill(0);
    noStroke();
    textAlign( CENTER );
    textFont( abel12 );
    text( "Cholesterol", 877 + 84 / 2, 586 - 84 + 12 );
  }

  void calculateTotals() {
    m_caloriesTotal = 0;
    m_caloriesFromFatTotal = 0;
    m_carbsGTotal = 0;
    m_carbsPTotal = 0;
    m_sugarsGTotal = 0;
    m_fiberGTotal = 0;
    m_fiberPTotal = 0;
    m_fatGTotal = 0;
    m_fatPTotal = 0;
    m_satFatGTotal = 0;
    m_satFatPTotal = 0;
    m_transFatGTotal = 0;
    m_proteinGTotal = 0;
    m_sodiumMTotal = 0;
    m_sodiumPTotal = 0;
    m_cholMTotal = 0;
    m_cholPTotal = 0;


    for (int i = 0; i < selectionsMenu.m_numProducts; i++ ) {
      int id = selectionsMenu.m_selectedProducts[i];
      for (int j = 0; j < products.size(); j++ ) {
        Product thisProduct = (Product) products.get(j);
        if ( thisProduct.m_id == id ) {
          m_caloriesTotal += thisProduct.m_calories * selectionsMenu.servingsMenu.m_servings[i];
          m_caloriesFromFatTotal += thisProduct.m_caloriesFromFat * selectionsMenu.servingsMenu.m_servings[i];
          m_carbsGTotal += thisProduct.m_carbsG * selectionsMenu.servingsMenu.m_servings[i];
          m_carbsPTotal += thisProduct.m_carbsP * selectionsMenu.servingsMenu.m_servings[i];
          m_sugarsGTotal += thisProduct.m_sugarsG * selectionsMenu.servingsMenu.m_servings[i];
          m_fiberGTotal += thisProduct.m_fiberG * selectionsMenu.servingsMenu.m_servings[i];
          m_fiberPTotal += thisProduct.m_fiberP * selectionsMenu.servingsMenu.m_servings[i];
          m_fatGTotal += thisProduct.m_fatG * selectionsMenu.servingsMenu.m_servings[i];
          m_fatPTotal += thisProduct.m_fatP * selectionsMenu.servingsMenu.m_servings[i];
          m_satFatGTotal += thisProduct.m_satFatG * selectionsMenu.servingsMenu.m_servings[i];
          m_satFatPTotal += thisProduct.m_satFatP * selectionsMenu.servingsMenu.m_servings[i];
          m_transFatGTotal += thisProduct.m_transFatG * selectionsMenu.servingsMenu.m_servings[i];
          m_proteinGTotal += thisProduct.m_proteinG * selectionsMenu.servingsMenu.m_servings[i];
          m_sodiumMTotal += thisProduct.m_sodiumM * selectionsMenu.servingsMenu.m_servings[i];
          m_sodiumPTotal += thisProduct.m_sodiumP * selectionsMenu.servingsMenu.m_servings[i];
          m_cholMTotal += thisProduct.m_cholM * selectionsMenu.servingsMenu.m_servings[i];
          m_cholPTotal += thisProduct.m_cholP * selectionsMenu.servingsMenu.m_servings[i];

          m_caloriesChart.m_stats[i] = thisProduct.m_calories * selectionsMenu.servingsMenu.m_servings[i];
          m_caloriesFromFatChart.m_stats[i] = thisProduct.m_caloriesFromFat * selectionsMenu.servingsMenu.m_servings[i];
          m_carbsGChart.m_stats[i] = thisProduct.m_carbsG * selectionsMenu.servingsMenu.m_servings[i];
          m_sugarsGChart.m_stats[i] = thisProduct.m_sugarsG * selectionsMenu.servingsMenu.m_servings[i];
          m_fiberGChart.m_stats[i] = thisProduct.m_fiberG * selectionsMenu.servingsMenu.m_servings[i];
          m_fatGChart.m_stats[i] = thisProduct.m_fatG * selectionsMenu.servingsMenu.m_servings[i];
          m_satFatGChart.m_stats[i] = thisProduct.m_satFatG * selectionsMenu.servingsMenu.m_servings[i];
          m_transFatGChart.m_stats[i] = thisProduct.m_transFatG * selectionsMenu.servingsMenu.m_servings[i];
          m_proteinGChart.m_stats[i] = thisProduct.m_proteinG * selectionsMenu.servingsMenu.m_servings[i];
          m_sodiumMChart.m_stats[i] = thisProduct.m_sodiumM * selectionsMenu.servingsMenu.m_servings[i];
          m_cholMChart.m_stats[i] = thisProduct.m_cholM * selectionsMenu.servingsMenu.m_servings[i];
        }
      }
    }
  }
}



class Chart {
  int[] m_stats;

  color[] m_colors;

  public Chart() {
    m_stats = new int[5];
    for (int i = 0; i < 5; i++ ) {
      m_stats[i] = 0;
    }
    
    m_colors = new color[5];
    m_colors[0] = color( 200, 34, 87 );
    m_colors[1] = color( 236, 197, 124 );
    m_colors[2] = color( 32, 139, 181 );
    m_colors[3] = color( 225, 133, 108 );
    m_colors[4] = color( 145, 149, 56 );
  }


  void render( int _x, int _y, int _scale ) {
    fill( 242, 242, 242 );
    noStroke();

    pushMatrix();
    translate( _x, _y );
    beginShape();
    vertex( 0, 0 ); 
    vertex( 84, 0 );
    vertex( 84, -84 );
    endShape( CLOSE );

    stroke( 0 );
    line( 0, 0, 84, 0 );
    line( 84, 0, 84, -84 );

    boolean changeScale = false;
    int maxStat = m_stats[0];
    for ( int i = 0; i < selectionsMenu.m_numProducts; i++ ) {
      if ( map( m_stats[i], 0, _scale, 0, 84 - 18 ) > 84 - 18 ) changeScale = true;
      if( m_stats[i] > maxStat ) maxStat = m_stats[i];
    }

    if ( changeScale == false ) {
      line( 84 - 3, -84 + 18, 84 + 3, -84 + 18 );
      textFont( abel12 );
      textAlign( LEFT );
      fill(0);
      noStroke();
      text( "100%", 88, -84 + 16 );
      text( "DV", 88, -84 + 29 );
    }
    else{
      line( 84 - 3, map( -_scale, 0, maxStat, 0, 84 - 18 ), 84 + 3, map( -_scale, 0, maxStat, 0, 84 - 18 ) );
      textFont( abel12 );
      textAlign( LEFT );
      fill(255, 0, 0);
      noStroke();
      text( "100%", 88, map( -_scale, 0, maxStat, 0, 84 - 18 ) - 3 );
      text( "DV", 88, map( -_scale, 0, maxStat, 0, 84 - 18 ) + 10 );      
    }

    int startX = 40 - selectionsMenu.m_numProducts * 5;
    
    //35
    //30, 40
    //25, 35, 45
    //20, 30, 40, 50
    //15, 25, 35, 45, 55

    for ( int i = 0; i < selectionsMenu.m_numProducts; i++ ) {
      fill( m_colors[i] );
      noStroke();

      if ( changeScale == false ) {
        rect( startX + 11 * i, 0, 10, map( -m_stats[i], 0, _scale, 0, 84 - 18 ) );
      }
      else {
        rect( startX + 11 * i, 0, 10, map( -m_stats[i], 0, maxStat, 0, 84 - 18 ) );        
      }
    }

    popMatrix();
  }
}

