class Product implements Comparable {
  int m_id;
  String m_description;
  String m_URL;
  String[] m_ingredients_raw;
  String[] m_ingredients;
  String m_servingSize;
  String m_perContainer;
  int m_calories;
  int m_caloriesFromFat;
  int m_carbsG;
  int m_carbsP;
  int m_sugarsG;
  int m_fiberG;
  int m_fiberP;
  int m_fatG;
  int m_fatP;
  int m_satFatG;
  int m_satFatP;
  int m_transFatG;
  int m_proteinG;
  int m_sodiumM;
  int m_sodiumP;
  int m_cholM;
  int m_cholP;

  public Product( 
  int _id, 
  String _description, 
  String _url, 
  String _ingredients, 
  String _servingSize, 
  String _perContainer, 
  String _calories, 
  String _caloriesFromFat, 
  String _carbsG, 
  String _carbsP, 
  String _sugarsG, 
  String _fiberG, 
  String _fiberP, 
  String _fatG, 
  String _fatP, 
  String _satFatG, 
  String _satFatP, 
  String _transFatG, 
  String _proteinG, 
  String _sodiumM, 
  String _sodiumP, 
  String _cholM, 
  String _cholP) {

    m_id = _id;
    m_description = _description;
    m_URL = _url;
    m_ingredients_raw = split(_ingredients, ',');
    m_servingSize = _servingSize;
    m_perContainer = _perContainer;
    m_calories = int(_calories);
    m_caloriesFromFat = int(_caloriesFromFat);
    m_carbsG = int(_carbsG);
    m_carbsP = int(_carbsP);
    m_sugarsG = int(_sugarsG);
    m_fiberG = int(_fiberG);
    m_fiberP = int(_fiberP);
    m_fatG = int(_fatG);
    m_fatP = int(_fatP);
    m_satFatG = int(_satFatG);
    m_satFatP = int(_satFatP);
    m_transFatG = int(_transFatG);
    m_proteinG = int(_proteinG);
    m_sodiumM = int(_sodiumM);
    m_sodiumP = int(_sodiumP);
    m_cholM = int(_cholM);
    m_cholP = int(_cholP);

    int countRealIngredients = 0;

    //Create the ingredients alpha hashmap
    for (int i = 0; i < m_ingredients_raw.length; i++) {
      //Use regular expressions and string matching to remove errors in the data
      //Regex gets rid of all cases containing: "Contains", ":", "To ", "added "
      //String matching gets rid of all cases where the entire string equals:
      // '(', ')', "with", "and", "and/or", "color(s)", "cured with", "from", "Includes"
      // "Or", "Other"
      String[] rx1 = match(m_ingredients_raw[i], "Contains");
      String[] rx2 = match( m_ingredients_raw[i], ":" );
      String[] rx3 = match( m_ingredients_raw[i], "To ");
      String[] rx4 = match( m_ingredients_raw[i], "added ");
      boolean sm1 = m_ingredients_raw[i].substring(0, 1).equals("(");
      boolean sm2 = m_ingredients_raw[i].substring(0, 1).equals(")");
      boolean sm3 = m_ingredients_raw[i].substring(0, 1).equals(":");
      boolean sm4 = m_ingredients_raw[i].equals("with");
      boolean sm5 = m_ingredients_raw[i].equals("and");
      boolean sm6 = m_ingredients_raw[i].equals("and/or");
      boolean sm7 = m_ingredients_raw[i].equals("color(s)");
      boolean sm8 = m_ingredients_raw[i].equals("cured with");
      boolean sm9 = m_ingredients_raw[i].equals("from");
      boolean sm10 = m_ingredients_raw[i].equals("Includes");
      boolean sm11 = m_ingredients_raw[i].equals("Or");
      boolean sm12 = m_ingredients_raw[i].equals("Other");

      // If none of the error conditions are met, add the product to the hashmap
      if ( rx1 == null && rx2 == null && rx3 == null && rx4 == null
        && !sm1 && !sm2 && !sm3 && !sm4 && !sm5 && !sm6 && !sm7
        && !sm8 && !sm9 && !sm10 && !sm11 && !sm12 ) {
        countRealIngredients++;
      }
    }

    m_ingredients = new String[countRealIngredients];
    countRealIngredients = 0;

    for (int i = 0; i < m_ingredients_raw.length; i++) {
      //Use regular expressions and string matching to remove errors in the data
      //Regex gets rid of all cases containing: "Contains", ":", "To ", "added "
      //String matching gets rid of all cases where the entire string equals:
      // '(', ')', "with", "and", "and/or", "color(s)", "cured with", "from", "Includes"
      // "Or", "Other"
      String[] rx1 = match(m_ingredients_raw[i], "Contains");
      String[] rx2 = match( m_ingredients_raw[i], ":" );
      String[] rx3 = match( m_ingredients_raw[i], "To ");
      String[] rx4 = match( m_ingredients_raw[i], "added ");
      boolean sm1 = m_ingredients_raw[i].substring(0, 1).equals("(");
      boolean sm2 = m_ingredients_raw[i].substring(0, 1).equals(")");
      boolean sm3 = m_ingredients_raw[i].substring(0, 1).equals(":");
      boolean sm4 = m_ingredients_raw[i].equals("with");
      boolean sm5 = m_ingredients_raw[i].equals("and");
      boolean sm6 = m_ingredients_raw[i].equals("and/or");
      boolean sm7 = m_ingredients_raw[i].equals("color(s)");
      boolean sm8 = m_ingredients_raw[i].equals("cured with");
      boolean sm9 = m_ingredients_raw[i].equals("from");
      boolean sm10 = m_ingredients_raw[i].equals("Includes");
      boolean sm11 = m_ingredients_raw[i].equals("Or");
      boolean sm12 = m_ingredients_raw[i].equals("Other");
      // If none of the error conditions are met, add the product to the hashmap
      if ( rx1 == null && rx2 == null && rx3 == null && rx4 == null
        && !sm1 && !sm2 && !sm3 && !sm4 && !sm5 && !sm6 && !sm7
        && !sm8 && !sm9 && !sm10 && !sm11 && !sm12 ) {
        m_ingredients[countRealIngredients] = m_ingredients_raw[i];
        countRealIngredients++;
      }
    }

    //Create the ingredients alpha hashmap
    for (int i = 0; i < m_ingredients.length; i++) {
      if (ingredientsKey.containsKey(m_ingredients[i])) {
        boolean foundAlternative = false;
        for ( int j = 0; j < ingredients.size(); j++) {
          Ingredient thisIngredient = (Ingredient) ingredients.get(j);
          if ( thisIngredient.m_description.equals( m_ingredients[i] ) ) {
            for ( int k = 0; k < thisIngredient.m_productCrossRef.size(); k++ ) {
              String thisProductCrossRef = (String) thisIngredient.m_productCrossRef.get(k);
              if ( m_description.equals( thisProductCrossRef ) ) {
                foundAlternative = true;
              }
            }
            if ( foundAlternative == false ) {
              thisIngredient.m_productCrossRef.add( m_description );
            }
          }
        }
      }
      else {
        ingredientsKey.put( m_ingredients[i], -1 );
        Ingredient newIngredient = new Ingredient( m_ingredients[i], m_description );
        ingredients.add( newIngredient );
      }
    }
  }

  // Overrides the collections object, not used to sort in this sketch
  int compareTo( Object _p ) {
    Product p2 = (Product) _p;

    return( m_id - p2.m_id );
  }
}

