class ChoiceSub {
  // ID
  String m_description;
  String m_heading;
  boolean m_display;
  int m_productNum;
  int m_pageDisplayed;

  // UI Measurements
  float m_placeY;
  float m_fullHeight;
  float m_buttonsHeight;
  float m_width;
  float m_placeX;
  float m_indent;
  float m_vertCenterText;

  SecondaryChooseButton[] b_buttons;
  PageButton b_up;
  PageButton b_down;

  // Constructor
  public ChoiceSub( float _placeX ) {
    m_productNum = -1;
    m_pageDisplayed = 0;
    m_heading = "";
    m_display = false;

    m_placeY = 71;
    m_fullHeight = 654;
    m_buttonsHeight = 28;
    m_width = 246;
    m_placeX = _placeX;
    m_indent = 10;
    m_vertCenterText = 21;
    b_buttons = new SecondaryChooseButton[0];
    b_up = new PageButton( true );
    b_down = new PageButton( false );
  }

  void createAlternativeButtons() {
    ArrayList theseAlternatives = new ArrayList<String>();
    if ( ingredientsKey.containsKey( m_description ) ) {

      for (int i = 0; i < ingredients.size(); i++) {
        Ingredient thisIngredient = (Ingredient) ingredients.get(i);
        if ( thisIngredient.m_description.equals( m_description ) ) {

          theseAlternatives = thisIngredient.m_productCrossRef;
        }
      }

      b_buttons = new SecondaryChooseButton[theseAlternatives.size()];

      println( m_description );

      for ( int i = 0; i < b_buttons.length; i++ ) {        
        String thisAlternative = (String) theseAlternatives.get(i);
        int id = -1;
        for ( int j = 0; j < products.size(); j++ ) {
          Product thisProduct = (Product) products.get(j);
          if ( thisProduct.m_description.equals( thisAlternative ) ) {
            id = thisProduct.m_id;
          }
        } 

        b_buttons[i] = new SecondaryChooseButton( 
        thisAlternative, 
        id, 
        m_placeX, 
        m_placeY, 
        m_width, 
        m_buttonsHeight, 
        i
          );
      }

      m_display = true;
    }
  }


  void createIngredientButtons() {
    Product thisProduct = (Product) products.get(m_productNum);
    b_buttons = new SecondaryChooseButton[thisProduct.m_ingredients.length];

    for (int i = 0; i < b_buttons.length; i++ ) {
      b_buttons[i] = new SecondaryChooseButton( 
      thisProduct.m_ingredients[i], 
      -1, 
      m_placeX, 
      m_placeY, 
      m_width, 
      m_buttonsHeight, 
      i
        );
    }
  }

  // Draw the box behind the menu
  void renderBackground() {
    fill( 255 );
    stroke ( 77, 77, 77 );
    rect( m_placeX, m_placeY, m_width, m_fullHeight );
  }

  void renderButtons() {
    int count = 0;
    if ( m_pageDisplayed < floor ( b_buttons.length / 22 ) ) {
      for ( int i = 22 * m_pageDisplayed; i < 22 + 22 * m_pageDisplayed; i++ ) {
        b_buttons[i].renderButton( m_placeX + m_width / 2, m_placeY + m_buttonsHeight * count + m_buttonsHeight / 2 );
        stroke( 0 );
        noFill();
        line( m_placeX, m_placeY + m_buttonsHeight * ( count + 1 ), m_placeX + m_width, m_placeY + m_buttonsHeight * ( count + 1 ) );
        count++;
      }
    }
    else {
      for ( int i = 22 * m_pageDisplayed; i < b_buttons.length; i++ ) {
        b_buttons[i].renderButton( m_placeX + m_width / 2, m_placeY + m_buttonsHeight * count + m_buttonsHeight / 2 );
        stroke( 0 );
        noFill();
        line( m_placeX, m_placeY + m_buttonsHeight * ( count + 1 ), m_placeX + m_width, m_placeY + m_buttonsHeight * ( count + 1 ) );
        count++;
      }
    }

    if ( b_buttons.length > 22 ){
     renderPageButtons(); 
      
    }
  }

  // Hide Scrolling Text
  void hideMenuScrolling() {
    noStroke();
    fill( 255 );
    rect( m_placeX, 0, m_width, m_placeY );
    rect( m_placeX, m_placeY + m_fullHeight + 1, m_placeX, height - ( m_placeY + m_fullHeight ) );

    stroke( 0 );
    noFill();
    // line at the top of the menu
    line( m_placeX, m_placeY, m_placeX + m_width, m_placeY );
    // line at the bottom of the menu
    line( m_placeX, m_placeY + m_fullHeight, m_placeX + m_width, m_placeY + m_fullHeight );
  }


  void renderProductHeading() {
    if ( m_heading.length() > 0 ) {
      String[] productString = splitTokens( m_heading, "\\(\\)" );
      String productName = productString[0];
      String productContainerSize = productString[1];

      textFont( abel15 );

      textFont( abel15 );
      fill(0);
      noStroke();
      textAlign( LEFT );
      text( productName, m_placeX + m_indent, m_placeY - m_vertCenterText );

      textFont( abel12 );
      fill( 0 );
      noStroke();
      textAlign( LEFT );
      text( productContainerSize + " Package Ingredients", m_placeX + m_indent, m_placeY - m_vertCenterText / 3 );
    }
  }

  void renderPageButtons() {
    pushMatrix();
    translate( m_placeX + m_width / 2 - 33 / 2, m_placeY + m_buttonsHeight * 22.7 );
    b_up.render ( 0, 0 );
    pushMatrix();
    translate( 20, 0 );
    b_down.render( 0, 0 );
    popMatrix();
    popMatrix();
  }

  // check for mouse interaction with the page buttons
  void checkPageButtons() {
    // If we clicked on the page down button
    if (
    mouseX >= b_down.m_screenX - 7 &&
      mouseX <= b_down.m_screenX + 7 &&
      mouseY >= b_down.m_screenY - 7 &&
      mouseY <= b_down.m_screenY + 7
      && m_pageDisplayed <= 12 ) {

      // Increment the page displayed
      m_pageDisplayed++;
      // Make sure we don't scroll off the list
      if ( m_pageDisplayed > floor( b_buttons.length / 22 ) ) {
        m_pageDisplayed = floor( b_buttons.length / 22 );
      }
    }

    // If we clicked on the page up button
    if (
    mouseX >= b_up.m_screenX - 7 &&
      mouseX <= b_up.m_screenX + 7 &&
      mouseY >= b_up.m_screenY - 7 &&
      mouseY <= b_up.m_screenY + 7
      && m_pageDisplayed >= 1 ) {

      // Devrement the page displayed
      m_pageDisplayed--;
      // Make sure we don't scroll off the list
      if ( m_pageDisplayed < 0 ) m_pageDisplayed = 0;
    }
  }
}

