PFont abel32, abel24, abel18, abel15, abel14, abel12;

//Controls which screen is displayed
boolean makeChoice = true;

// Use the Processing convenience class for tables to read in and store the data
Table t_products;
ArrayList<Product> products = new ArrayList();
HashMap productKey = new HashMap();
HashMap ingredientsKey = new HashMap();

// Class to store the ingredients and associated products
ArrayList<Ingredient> ingredients = new ArrayList();

// Object to control choice selection
ChoiceMaster selectionsMenu;
ChartMaster chart;

void setup() {
  size( 1024, 768, P2D );

  // Load the fonts
  abel32 = loadFont( "Abel-32.vlw" );
  abel24 = loadFont( "Abel-24.vlw" );
  abel18 = loadFont( "Abel-18.vlw" );
  abel15 = loadFont( "Abel-15.vlw" );
  abel14 = loadFont( "Abel-14.vlw" );
  abel12 = loadFont( "Abel-12.vlw" );

  // Load in the csv file into the Processing Table object
  t_products = new Table (this, "IngredientsTable.txt" );

  // For all of the rows, take the element out of the table and put it into the
  // Products object container
  int productCount = 0;
  for ( int i = 1; i < t_products.getRowCount(); i++ ) {
    if ( !productKey.containsKey( t_products.getString(i, 0) ) ) {
      productKey.put( t_products.getString(i, 0), productCount );

      Product readProduct = new Product(
      productCount, //   int _id,
      t_products.getString(i, 0), //   String _desc, 
      t_products.getString(i, 1), //   String _url, 
      t_products.getString(i, 2), //   String _ingr,
      t_products.getString(i, 3), //   String _serv,
      t_products.getString(i, 4), //   String _per,
      t_products.getString(i, 5), //   String _cal,
      t_products.getString(i, 6), //   String _calFat,
      t_products.getString(i, 7), //   String _carbsG,
      t_products.getString(i, 8), //   String _carbsP,
      t_products.getString(i, 9), //   String _sugarsG,
      t_products.getString(i, 10), //   String _fiberG,
      t_products.getString(i, 11), //   String _fiberP,
      t_products.getString(i, 12), //   String _fatG,
      t_products.getString(i, 13), //   String _fatP,
      t_products.getString(i, 14), //   String _satFatG,
      t_products.getString(i, 15), //   String _satFatP,
      t_products.getString(i, 16), //   String _transFatG,
      t_products.getString(i, 17), //   String _proteinG,
      t_products.getString(i, 18), //   String _sodiumM,
      t_products.getString(i, 19), //   String _sodiumP,
      t_products.getString(i, 20), //   String _cholM,
      t_products.getString(i, 21)  //   String _cholP
      );

      productCount++;
      // Add the completely read product into the list of products
      products.add(readProduct);
    }
  }

  // Create the UI menu structure fo rthe products
  selectionsMenu = new ChoiceMaster( products.size() );
  selectionsMenu.createProductButtons( products );

  chart = new ChartMaster();

  for (int i = 0; i < ingredients.size(); i++ ) {
    Ingredient thisIngredient = (Ingredient) ingredients.get(i);
    println( thisIngredient.m_description );
    for ( int j = 0; j < thisIngredient.m_productCrossRef.size(); j++ ) {
      String thisProduct = (String) thisIngredient.m_productCrossRef.get(j);
      println( thisProduct );
    }
    println();
  }
}


void draw() {
  background(255);

  // If we're currently chosing our products, show the choice screen
  if ( makeChoice == true ) {
    choiceScreen();
  }
  // If we're looking at charts, show the chart screen
  else {
    chartScreen();
  }
}

